<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_131) on Mon Jul 17 12:51:54 CEST 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>SimpleBoard (APP)</title>
<meta name="date" content="2017-07-17">
<link rel="stylesheet" type="text/css" href="../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="SimpleBoard (APP)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":9,"i18":10,"i19":10,"i20":10,"i21":10,"i22":10,"i23":10,"i24":10,"i25":10,"i26":10,"i27":10,"i28":10,"i29":10,"i30":10,"i31":10,"i32":10,"i33":10,"i34":10,"i35":10,"i36":10,"i37":10,"i38":10,"i39":10,"i40":10,"i41":10,"i42":10,"i43":10,"i44":10,"i45":10,"i46":10,"i47":10,"i48":10};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/SimpleBoard.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-all.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../towerwarspp/board/MoveScore.html" title="class in towerwarspp.board"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li>Next&nbsp;Class</li>
</ul>
<ul class="navList">
<li><a href="../../index.html?towerwarspp/board/SimpleBoard.html" target="_top">Frames</a></li>
<li><a href="SimpleBoard.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">towerwarspp.board</div>
<h2 title="Class SimpleBoard" class="title">Class SimpleBoard</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>towerwarspp.board.SimpleBoard</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="../../towerwarspp/preset/Viewable.html" title="interface in towerwarspp.preset">Viewable</a></dd>
</dl>
<dl>
<dt>Direct Known Subclasses:</dt>
<dd><a href="../../towerwarspp/board/Board.html" title="class in towerwarspp.board">Board</a></dd>
</dl>
<hr>
<br>
<pre>public class <span class="typeNameLabel">SimpleBoard</span>
extends java.lang.Object
implements <a href="../../towerwarspp/preset/Viewable.html" title="interface in towerwarspp.preset">Viewable</a></pre>
<div class="block">This class represents the board on which all players' moves have to be executed.
 It contains information about all tokens which are currently on the board as well as about the current turn and game status.
 It executes new moves conducting all necessary changes respectively and recognises if the new move is a legal one
 and if it leads to the end of the game. Illegal moves will not be executed. Instead, the SimpleBoard's status will be set to ILLEGAL.
 If the game is finished, the SimpleBoard saves the information on the win type.</div>
<dl>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>15-07-17</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Anastasiia Kysliak</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#blueBase">blueBase</a></span></code>
<div class="block">The position of the blue base.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>[][]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#board">board</a></span></code>
<div class="block">The representation of the board as a 2-dimensional array of Entities.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected <a href="../../towerwarspp/util/debug/Debug.html" title="class in towerwarspp.util.debug">Debug</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#debug">debug</a></span></code>
<div class="block">Instance of the class <a href="../../towerwarspp/util/debug/Debug.html" title="class in towerwarspp.util.debug"><code>Debug</code></a>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private <a href="../../towerwarspp/board/Hexagon.html" title="class in towerwarspp.board">Hexagon</a>[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#directions">directions</a></span></code>
<div class="block">A list of <a href="../../towerwarspp/board/Hexagon.html" title="class in towerwarspp.board"><code>Hexagon</code></a> objects representing all possible directions on the board.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#listBlue">listBlue</a></span></code>
<div class="block">A list of all potentially movable tokens belonging to the blue player.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#listRed">listRed</a></span></code>
<div class="block">A list of all potentially movable tokens belonging to the red player.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#redBase">redBase</a></span></code>
<div class="block">The position of the red base.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#size">size</a></span></code>
<div class="block">The size of the board.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="../../towerwarspp/preset/Status.html" title="enum in towerwarspp.preset">Status</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#status">status</a></span></code>
<div class="block">The current board satus.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#turn">turn</a></span></code>
<div class="block">The current turn.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private <a href="../../towerwarspp/main/WinType.html" title="enum in towerwarspp.main">WinType</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#winType">winType</a></span></code>
<div class="block">Stores the information on the win type if the game is finished.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#SimpleBoard-int-">SimpleBoard</a></span>(int&nbsp;n)</code>
<div class="block">Initialises a new object of the class SimpleBoard.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#SimpleBoard-int-towerwarspp.preset.PlayerColor-java.util.Vector-java.util.Vector-towerwarspp.board.Entity:A:A-towerwarspp.preset.Position-towerwarspp.preset.Position-">SimpleBoard</a></span>(int&nbsp;size,
           <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;turn,
           java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;&nbsp;lRed,
           java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;&nbsp;lBlue,
           <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>[][]&nbsp;board,
           <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;redB,
           <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;blueB)</code>
<div class="block">Initialises a new object of the class SimpleBoard with the specified parameters.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t1" class="tableTab"><span><a href="javascript:show(1);">Static Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#actualiseOwnTowerUnblockedOrIncreased-towerwarspp.board.Entity-int-">actualiseOwnTowerUnblockedOrIncreased</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower,
                                     int&nbsp;change)</code>
<div class="block">Commits changes caused by creating, increasing or unblocking of a tower in respect to its neighbours of the same color.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#actualiseTowerAddStone-towerwarspp.board.Entity-">actualiseTowerAddStone</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower)</code>
<div class="block">Commits all necessary changes caused by putting a stone on the top of the specified token (stone or tower):
 1.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#actualiseTowerNeighbourIsEmpty-towerwarspp.preset.Position-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-">actualiseTowerNeighbourIsEmpty</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;emptyPos,
                              <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos,
                              <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col)</code>
<div class="block">Proves if there is a tower on the position pos which is not blocked and has color different from col.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#actualiseTowerNeighboursRemoveRanges-towerwarspp.board.Entity-int-">actualiseTowerNeighboursRemoveRanges</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower,
                                    int&nbsp;change)</code>
<div class="block">Commits changes caused by blocking, removing or dismantling of a tower in respect to its neighbours of the same color.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#actualiseTowerRemoved-towerwarspp.board.Entity-">actualiseTowerRemoved</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower)</code>
<div class="block">Commits some necessary changes caused by removing a tower.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#actualiseTowerRemoveStone-towerwarspp.board.Entity-">actualiseTowerRemoveStone</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower)</code>
<div class="block">Commits all necessary changes caused by removing a stone from the top of the specified tower:
 1.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#addMove-towerwarspp.board.Entity-towerwarspp.preset.Position-int-">addMove</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent,
       <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos,
       int&nbsp;range)</code>
<div class="block">Adds a move to the specified end position to the list of all possible moves of the specified token.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#addRanges-towerwarspp.board.Entity-int-">addRanges</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;stone,
         int&nbsp;n)</code>
<div class="block">Increases the step range of the specified token (stone) by n and adds
 newly available positions in the new range to its list of possible moves.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#addToList-towerwarspp.board.Entity-">addToList</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent)</code>
<div class="block">Adds the specified token to the list of movable tokens of the corresponding color.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#blockTower-towerwarspp.board.Entity-towerwarspp.board.Entity-">blockTower</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower,
          <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;blockingStone)</code>
<div class="block">Blocks the specified tower and commits all the necessary changes:
 1.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#changeEnd-towerwarspp.board.Entity-towerwarspp.preset.Position-towerwarspp.preset.Position-">changeEnd</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent,
         <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;start,
         <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;end)</code>
<div class="block">Conducts changes caused by the current move, which is specified for the token ent, in respect to its end position.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>private <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#changeStart-towerwarspp.board.Entity-towerwarspp.preset.Position-">changeStart</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent,
           <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;start)</code>
<div class="block">Conducts changes caused by the current move, which is specified for the token ent, in respect to its start position.</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#checkMoveForStone-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-int-">checkMoveForStone</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos,
                 <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col,
                 int&nbsp;dist)</code>
<div class="block">Returns true if a stone of the color col can go to the position pos taking into account the art of the move in question (close or remote one).</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#checkMoveForTower-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-">checkMoveForTower</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos,
                 <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col)</code>
<div class="block">Returns true if a tower of the color col neighbouring to the position pos can be dismantled on this position.</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>private <a href="../../towerwarspp/preset/Status.html" title="enum in towerwarspp.preset">Status</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#checkWin-towerwarspp.preset.Position-">checkWin</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;lastMove)</code>
<div class="block">Proves if the last move to the position lastMove was a winning one and returns the corresponding status.</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#decHeight-towerwarspp.board.Entity-">decHeight</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower)</code>
<div class="block">Decreases the height of the specified token.</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#decRange-towerwarspp.board.Entity-">decRange</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent)</code>
<div class="block">Decreases the step range of the specified token (stone) by one.</div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>static int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#distance-towerwarspp.preset.Position-towerwarspp.preset.Position-">distance</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;a,
        <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;b)</code>
<div class="block">Calculates the distance between two positions on the board.</div>
</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code>private java.util.Vector&lt;<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#findPositionsInRange-towerwarspp.preset.Position-int-">findPositionsInRange</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;center,
                    int&nbsp;radius)</code>
<div class="block">Returns all positions on the board which lay on the ring with the specified center and the specified radius.</div>
</td>
</tr>
<tr id="i19" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#findStoneMoves-towerwarspp.board.Entity-">findStoneMoves</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;stone)</code>
<div class="block">Finds all possible moves for the specified stone.</div>
</td>
</tr>
<tr id="i20" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#findTowerMoves-towerwarspp.board.Entity-">findTowerMoves</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower)</code>
<div class="block">Finds all possible moves for the specified tower.</div>
</td>
</tr>
<tr id="i21" class="rowColor">
<td class="colFirst"><code>protected <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#getElement-towerwarspp.preset.Position-">getElement</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos)</code>
<div class="block">Returns the token located on the specified position on the board.</div>
</td>
</tr>
<tr id="i22" class="altColor">
<td class="colFirst"><code>protected java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#getEntityList-towerwarspp.preset.PlayerColor-">getEntityList</a></span>(<a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col)</code>
<div class="block">Returns the list of movable tokens of the specified color.</div>
</td>
</tr>
<tr id="i23" class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#getSize--">getSize</a></span>()</code>
<div class="block">Returns the size of the board.</div>
</td>
</tr>
<tr id="i24" class="altColor">
<td class="colFirst"><code><a href="../../towerwarspp/preset/Status.html" title="enum in towerwarspp.preset">Status</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#getStatus--">getStatus</a></span>()</code>
<div class="block">Returns the status of the board.</div>
</td>
</tr>
<tr id="i25" class="rowColor">
<td class="colFirst"><code><a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#getTurn--">getTurn</a></span>()</code>
<div class="block">Returns the current turn.</div>
</td>
</tr>
<tr id="i26" class="altColor">
<td class="colFirst"><code><a href="../../towerwarspp/main/WinType.html" title="enum in towerwarspp.main">WinType</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#getWinType--">getWinType</a></span>()</code>
<div class="block">Returns the WinType or null if the game is not finished.</div>
</td>
</tr>
<tr id="i27" class="rowColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#hasMoves-towerwarspp.preset.PlayerColor-">hasMoves</a></span>(<a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col)</code>
<div class="block">Returns true if the player of the color col has at least one move.</div>
</td>
</tr>
<tr id="i28" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#incHeight-towerwarspp.board.Entity-">incHeight</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower)</code>
<div class="block">Increases the height of the specified token.</div>
</td>
</tr>
<tr id="i29" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#incRange-towerwarspp.board.Entity-">incRange</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent)</code>
<div class="block">Increases the step range of the specified token (stone) by one without
 adding any new moves to its list of possible moves.</div>
</td>
</tr>
<tr id="i30" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#initialiseBoard--">initialiseBoard</a></span>()</code>
<div class="block">Initialises the board before the first move:
 1.</div>
</td>
</tr>
<tr id="i31" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#initialiseEntities-towerwarspp.preset.Position-int-towerwarspp.preset.PlayerColor-java.util.Vector-">initialiseEntities</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;base,
                  int&nbsp;dist,
                  <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col,
                  java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;&nbsp;list)</code>
<div class="block">Initialises all entities of the specified color before the first move.</div>
</td>
</tr>
<tr id="i32" class="altColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#isOnBoard-int-int-">isOnBoard</a></span>(int&nbsp;x,
         int&nbsp;y)</code>
<div class="block">Returns true if the position with the specified coordinates lays on the board.</div>
</td>
</tr>
<tr id="i33" class="rowColor">
<td class="colFirst"><code><a href="../../towerwarspp/preset/Status.html" title="enum in towerwarspp.preset">Status</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#makeMove-towerwarspp.preset.Move-">makeMove</a></span>(<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;move)</code>
<div class="block">Executes the specified move if this move is legal.</div>
</td>
</tr>
<tr id="i34" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#moveAllowed-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-">moveAllowed</a></span>(<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;move,
           <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col)</code>
<div class="block">Returns true if the player of the specified color can make the specified move.</div>
</td>
</tr>
<tr id="i35" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#positionClosed-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-boolean-">positionClosed</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;closedPos,
              <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col,
              boolean&nbsp;forAll)</code>
<div class="block">Removes the specified position from the list of possible moves for every token of the specified color
 if this token can reach the position and satisfies the specified requirement (if available).</div>
</td>
</tr>
<tr id="i36" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#positionClosedAndOpenedForTowers-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-boolean-">positionClosedAndOpenedForTowers</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos,
                                <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col,
                                boolean&nbsp;openForOpponent)</code>
<div class="block">Removes the specified position from the list of possible moves for all neighbouring towers of the specified color.</div>
</td>
</tr>
<tr id="i37" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#positionOpened-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-">positionOpened</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;openedPos,
              <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col)</code>
<div class="block">Adds the specified position to the list of possible moves for every token of the specified color
 if this token can reach the position.</div>
</td>
</tr>
<tr id="i38" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#positionOpenedStonesOnly-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-">positionOpenedStonesOnly</a></span>(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;openedPos,
                        <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col)</code>
<div class="block">Adds the specified position to the list of possible moves for every stone (and not for the towers)
 if this stone can reach the position.</div>
</td>
</tr>
<tr id="i39" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#removeAllMoves-towerwarspp.board.Entity-">removeAllMoves</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent)</code>
<div class="block">Removes all moves of the specified token.</div>
</td>
</tr>
<tr id="i40" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#removeFromList-towerwarspp.board.Entity-">removeFromList</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent)</code>
<div class="block">Removes the specified token from the the list of movable tokens of the corresponding color.</div>
</td>
</tr>
<tr id="i41" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#removeMove-towerwarspp.board.Entity-towerwarspp.preset.Position-int-">removeMove</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent,
          <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos,
          int&nbsp;range)</code>
<div class="block">Removes the move to the specified end position from the list of all possible moves of the specified token.</div>
</td>
</tr>
<tr id="i42" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#removeRanges-towerwarspp.board.Entity-int-">removeRanges</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent,
            int&nbsp;n)</code>
<div class="block">Decreases the step range of the specified token and removes all corresponding moves
 from the specified token's list of possible moves.</div>
</td>
</tr>
<tr id="i43" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#removeToken-towerwarspp.board.Entity-towerwarspp.board.Entity-">removeToken</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent,
           <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;removingStone)</code>
<div class="block">Removes the specified token ent from the board replacing it with the stone removingStone.</div>
</td>
</tr>
<tr id="i44" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#setBlocked-towerwarspp.board.Entity-boolean-">setBlocked</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower,
          boolean&nbsp;block)</code>
<div class="block">Blocks or unblocks the specified tower.</div>
</td>
</tr>
<tr id="i45" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#setElement-towerwarspp.board.Entity-towerwarspp.preset.Position-">setElement</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent,
          <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos)</code>
<div class="block">Puts the specified token on the specified position on the board.</div>
</td>
</tr>
<tr id="i46" class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#setPosition-towerwarspp.board.Entity-towerwarspp.preset.Position-">setPosition</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent,
           <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos)</code>
<div class="block">Sets a new position for the specified token.</div>
</td>
</tr>
<tr id="i47" class="rowColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#unblockTower-towerwarspp.board.Entity-towerwarspp.board.Entity-">unblockTower</a></span>(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower,
            <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;unblockingStone)</code>
<div class="block">Unblocks the specified tower, removes the and commits all the necessary changes.</div>
</td>
</tr>
<tr id="i48" class="altColor">
<td class="colFirst"><code><a href="../../towerwarspp/board/BViewer.html" title="class in towerwarspp.board">BViewer</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../towerwarspp/board/SimpleBoard.html#viewer--">viewer</a></span>()</code>
<div class="block">Returns a viewer for this board.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="directions">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>directions</h4>
<pre>private final&nbsp;<a href="../../towerwarspp/board/Hexagon.html" title="class in towerwarspp.board">Hexagon</a>[] directions</pre>
<div class="block">A list of <a href="../../towerwarspp/board/Hexagon.html" title="class in towerwarspp.board"><code>Hexagon</code></a> objects representing all possible directions on the board.</div>
</li>
</ul>
<a name="size">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>size</h4>
<pre>protected&nbsp;int size</pre>
<div class="block">The size of the board.</div>
</li>
</ul>
<a name="turn">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>turn</h4>
<pre>protected&nbsp;<a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a> turn</pre>
<div class="block">The current turn.</div>
</li>
</ul>
<a name="listRed">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>listRed</h4>
<pre>protected&nbsp;java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt; listRed</pre>
<div class="block">A list of all potentially movable tokens belonging to the red player.
 This list contais only stones and towers (blocked and not blocked), but not the base.</div>
</li>
</ul>
<a name="listBlue">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>listBlue</h4>
<pre>protected&nbsp;java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt; listBlue</pre>
<div class="block">A list of all potentially movable tokens belonging to the blue player.
 This list contais only stones and towers (blocked and not blocked), but not the base.</div>
</li>
</ul>
<a name="redBase">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>redBase</h4>
<pre>protected&nbsp;<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a> redBase</pre>
<div class="block">The position of the red base.</div>
</li>
</ul>
<a name="blueBase">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>blueBase</h4>
<pre>protected&nbsp;<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a> blueBase</pre>
<div class="block">The position of the blue base.</div>
</li>
</ul>
<a name="debug">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>debug</h4>
<pre>protected&nbsp;<a href="../../towerwarspp/util/debug/Debug.html" title="class in towerwarspp.util.debug">Debug</a> debug</pre>
<div class="block">Instance of the class <a href="../../towerwarspp/util/debug/Debug.html" title="class in towerwarspp.util.debug"><code>Debug</code></a>.</div>
</li>
</ul>
<a name="status">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>status</h4>
<pre>private&nbsp;<a href="../../towerwarspp/preset/Status.html" title="enum in towerwarspp.preset">Status</a> status</pre>
<div class="block">The current board satus.</div>
</li>
</ul>
<a name="board">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>board</h4>
<pre>private&nbsp;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>[][] board</pre>
<div class="block">The representation of the board as a 2-dimensional array of Entities.</div>
</li>
</ul>
<a name="winType">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>winType</h4>
<pre>private&nbsp;<a href="../../towerwarspp/main/WinType.html" title="enum in towerwarspp.main">WinType</a> winType</pre>
<div class="block">Stores the information on the win type if the game is finished. This variable has value null as long as the game is not finished.</div>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="SimpleBoard-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>SimpleBoard</h4>
<pre>public&nbsp;SimpleBoard(int&nbsp;n)</pre>
<div class="block">Initialises a new object of the class SimpleBoard.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>n</code> - size of the new board.</dd>
</dl>
</li>
</ul>
<a name="SimpleBoard-int-towerwarspp.preset.PlayerColor-java.util.Vector-java.util.Vector-towerwarspp.board.Entity:A:A-towerwarspp.preset.Position-towerwarspp.preset.Position-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>SimpleBoard</h4>
<pre>public&nbsp;SimpleBoard(int&nbsp;size,
                   <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;turn,
                   java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;&nbsp;lRed,
                   java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;&nbsp;lBlue,
                   <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>[][]&nbsp;board,
                   <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;redB,
                   <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;blueB)</pre>
<div class="block">Initialises a new object of the class SimpleBoard with the specified parameters.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>size</code> - size of the new board.</dd>
<dd><code>turn</code> - current turn.</dd>
<dd><code>lRed</code> - list of all red entities except the red base.</dd>
<dd><code>lBlue</code> - list of all blue entities except the blue base.</dd>
<dd><code>board</code> - representation of the board as a 2-dimensional array of entities.</dd>
<dd><code>redB</code> - position of the red base.</dd>
<dd><code>blueB</code> - position of the blue base.</dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getSize--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSize</h4>
<pre>public&nbsp;int&nbsp;getSize()</pre>
<div class="block">Returns the size of the board.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the size of the board.</dd>
</dl>
</li>
</ul>
<a name="getTurn--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTurn</h4>
<pre>public&nbsp;<a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;getTurn()</pre>
<div class="block">Returns the current turn.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the curren turn.</dd>
</dl>
</li>
</ul>
<a name="getStatus--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getStatus</h4>
<pre>public&nbsp;<a href="../../towerwarspp/preset/Status.html" title="enum in towerwarspp.preset">Status</a>&nbsp;getStatus()</pre>
<div class="block">Returns the status of the board.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the status of the board.</dd>
</dl>
</li>
</ul>
<a name="getWinType--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getWinType</h4>
<pre>public&nbsp;<a href="../../towerwarspp/main/WinType.html" title="enum in towerwarspp.main">WinType</a>&nbsp;getWinType()</pre>
<div class="block">Returns the WinType or null if the game is not finished.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the WinType or null if the game is not finished.</dd>
</dl>
</li>
</ul>
<a name="distance-towerwarspp.preset.Position-towerwarspp.preset.Position-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>distance</h4>
<pre>public static&nbsp;int&nbsp;distance(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;a,
                           <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;b)</pre>
<div class="block">Calculates the distance between two positions on the board.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>a</code> - the first position.</dd>
<dd><code>b</code> - the second position.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the distance between the positions a and b.</dd>
</dl>
</li>
</ul>
<a name="moveAllowed-towerwarspp.preset.Move-towerwarspp.preset.PlayerColor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>moveAllowed</h4>
<pre>public&nbsp;boolean&nbsp;moveAllowed(<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;move,
                           <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col)</pre>
<div class="block">Returns true if the player of the specified color can make the specified move.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>move</code> - the move in question.</dd>
<dd><code>col</code> - the color of the player in question.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if the player of the color col can make the specified move.</dd>
</dl>
</li>
</ul>
<a name="makeMove-towerwarspp.preset.Move-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>makeMove</h4>
<pre>public&nbsp;<a href="../../towerwarspp/preset/Status.html" title="enum in towerwarspp.preset">Status</a>&nbsp;makeMove(<a href="../../towerwarspp/preset/Move.html" title="class in towerwarspp.preset">Move</a>&nbsp;move)</pre>
<div class="block">Executes the specified move if this move is legal. Changes the board status and the turn accordingly.
 If the move is illegal, the turn will not be changed.
 Returns the current status of the board.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>move</code> - new move to be executed.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>actualised status of the board.</dd>
</dl>
</li>
</ul>
<a name="getEntityList-towerwarspp.preset.PlayerColor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getEntityList</h4>
<pre>protected&nbsp;java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;&nbsp;getEntityList(<a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col)</pre>
<div class="block">Returns the list of movable tokens of the specified color.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>col</code> - the color of the tokens in question.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the list of movable tokens of the specified color.</dd>
</dl>
</li>
</ul>
<a name="getElement-towerwarspp.preset.Position-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getElement</h4>
<pre>protected&nbsp;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;getElement(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos)</pre>
<div class="block">Returns the token located on the specified position on the board.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>pos</code> - the position of the token that has to be returned.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the token located on the specified position on the board.</dd>
</dl>
</li>
</ul>
<a name="setElement-towerwarspp.board.Entity-towerwarspp.preset.Position-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setElement</h4>
<pre>private&nbsp;void&nbsp;setElement(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent,
                        <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos)</pre>
<div class="block">Puts the specified token on the specified position on the board.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>ent</code> - the token in question.</dd>
<dd><code>pos</code> - position for the specified token to be placed on.</dd>
</dl>
</li>
</ul>
<a name="setBlocked-towerwarspp.board.Entity-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setBlocked</h4>
<pre>private&nbsp;void&nbsp;setBlocked(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower,
                        boolean&nbsp;block)</pre>
<div class="block">Blocks or unblocks the specified tower.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>tower</code> - the tower which has to be blocked.</dd>
<dd><code>block</code> - specifies if the tower in question has to be blocked or unblocked (if block == true, the tower has to be blocked).</dd>
</dl>
</li>
</ul>
<a name="addMove-towerwarspp.board.Entity-towerwarspp.preset.Position-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addMove</h4>
<pre>private&nbsp;void&nbsp;addMove(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent,
                     <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos,
                     int&nbsp;range)</pre>
<div class="block">Adds a move to the specified end position to the list of all possible moves of the specified token.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>ent</code> - the token which has to have a move to the specified position.</dd>
<dd><code>pos</code> - the end position of the move which has to be possible for the specified token.</dd>
<dd><code>range</code> - distance to the position pos from the token's current position.</dd>
</dl>
</li>
</ul>
<a name="removeMove-towerwarspp.board.Entity-towerwarspp.preset.Position-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeMove</h4>
<pre>private&nbsp;void&nbsp;removeMove(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent,
                        <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos,
                        int&nbsp;range)</pre>
<div class="block">Removes the move to the specified end position from the list of all possible moves of the specified token.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>ent</code> - the token whose move to the specified position has to be removed from its list of possible moves.</dd>
<dd><code>pos</code> - the end position of the move which has to be removed from the token's possible moves list.</dd>
<dd><code>range</code> - distance to the position pos from the token's current position.</dd>
</dl>
</li>
</ul>
<a name="removeAllMoves-towerwarspp.board.Entity-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeAllMoves</h4>
<pre>private&nbsp;void&nbsp;removeAllMoves(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent)</pre>
<div class="block">Removes all moves of the specified token.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>ent</code> - the token whose moves have to be removed.</dd>
</dl>
</li>
</ul>
<a name="addRanges-towerwarspp.board.Entity-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addRanges</h4>
<pre>private&nbsp;void&nbsp;addRanges(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;stone,
                       int&nbsp;n)</pre>
<div class="block">Increases the step range of the specified token (stone) by n and adds
 newly available positions in the new range to its list of possible moves.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>stone</code> - the token (stone) whose step range has to be increased.</dd>
<dd><code>n</code> - the required change of the step range.</dd>
</dl>
</li>
</ul>
<a name="removeRanges-towerwarspp.board.Entity-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeRanges</h4>
<pre>private&nbsp;void&nbsp;removeRanges(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent,
                          int&nbsp;n)</pre>
<div class="block">Decreases the step range of the specified token and removes all corresponding moves
 from the specified token's list of possible moves.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>ent</code> - the token in question.</dd>
<dd><code>n</code> - the required change of the step range.</dd>
</dl>
</li>
</ul>
<a name="incRange-towerwarspp.board.Entity-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>incRange</h4>
<pre>private&nbsp;void&nbsp;incRange(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent)</pre>
<div class="block">Increases the step range of the specified token (stone) by one without
 adding any new moves to its list of possible moves.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>ent</code> - the token whose step range has to be increased.</dd>
</dl>
</li>
</ul>
<a name="decRange-towerwarspp.board.Entity-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decRange</h4>
<pre>private&nbsp;void&nbsp;decRange(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent)</pre>
<div class="block">Decreases the step range of the specified token (stone) by one.
 All moves which are no more possible will be removed from the token's list of possible moves.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>ent</code> - the token whose step range has to be decreased.</dd>
</dl>
</li>
</ul>
<a name="incHeight-towerwarspp.board.Entity-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>incHeight</h4>
<pre>private&nbsp;void&nbsp;incHeight(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower)</pre>
<div class="block">Increases the height of the specified token.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>tower</code> - the token whose height has to be increased.</dd>
</dl>
</li>
</ul>
<a name="decHeight-towerwarspp.board.Entity-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decHeight</h4>
<pre>private&nbsp;void&nbsp;decHeight(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower)</pre>
<div class="block">Decreases the height of the specified token.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>tower</code> - the token whose height has to be decreased.</dd>
</dl>
</li>
</ul>
<a name="setPosition-towerwarspp.board.Entity-towerwarspp.preset.Position-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setPosition</h4>
<pre>private&nbsp;void&nbsp;setPosition(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent,
                         <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos)</pre>
<div class="block">Sets a new position for the specified token.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>ent</code> - the token whose position has to be changed.</dd>
<dd><code>pos</code> - the new position.</dd>
</dl>
</li>
</ul>
<a name="addToList-towerwarspp.board.Entity-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addToList</h4>
<pre>private&nbsp;void&nbsp;addToList(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent)</pre>
<div class="block">Adds the specified token to the list of movable tokens of the corresponding color.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>ent</code> - the token in question.</dd>
</dl>
</li>
</ul>
<a name="removeFromList-towerwarspp.board.Entity-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeFromList</h4>
<pre>private&nbsp;void&nbsp;removeFromList(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent)</pre>
<div class="block">Removes the specified token from the the list of movable tokens of the corresponding color.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>ent</code> - the token in question.</dd>
</dl>
</li>
</ul>
<a name="checkWin-towerwarspp.preset.Position-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>checkWin</h4>
<pre>private&nbsp;<a href="../../towerwarspp/preset/Status.html" title="enum in towerwarspp.preset">Status</a>&nbsp;checkWin(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;lastMove)</pre>
<div class="block">Proves if the last move to the position lastMove was a winning one and returns the corresponding status.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>lastMove</code> - end position of the last move.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>RED_WIN if the red player has won;
 BLUE_WIN if the blue player has won;
 OK if the move was not winning.</dd>
</dl>
</li>
</ul>
<a name="hasMoves-towerwarspp.preset.PlayerColor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>hasMoves</h4>
<pre>private&nbsp;boolean&nbsp;hasMoves(<a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col)</pre>
<div class="block">Returns true if the player of the color col has at least one move.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>col</code> - the color of the player in question.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if the player of the color col has at least one move.</dd>
</dl>
</li>
</ul>
<a name="findPositionsInRange-towerwarspp.preset.Position-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>findPositionsInRange</h4>
<pre>private&nbsp;java.util.Vector&lt;<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&gt;&nbsp;findPositionsInRange(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;center,
                                                        int&nbsp;radius)</pre>
<div class="block">Returns all positions on the board which lay on the ring with the specified center and the specified radius.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>center</code> - position of the ring's center.</dd>
<dd><code>radius</code> - the ring's radius.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>all positions on the board which lay on the ring with the specified center and the specified radius.</dd>
</dl>
</li>
</ul>
<a name="isOnBoard-int-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isOnBoard</h4>
<pre>private&nbsp;boolean&nbsp;isOnBoard(int&nbsp;x,
                          int&nbsp;y)</pre>
<div class="block">Returns true if the position with the specified coordinates lays on the board.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>x</code> - x-coordinate of the position in question.</dd>
<dd><code>y</code> - y-coordinate of the position in question.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if the position (x, y) lays on the board.</dd>
</dl>
</li>
</ul>
<a name="changeStart-towerwarspp.board.Entity-towerwarspp.preset.Position-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>changeStart</h4>
<pre>private&nbsp;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;changeStart(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent,
                           <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;start)</pre>
<div class="block">Conducts changes caused by the current move, which is specified for the token ent, in respect to its start position.
 If the moving token is a tower;
 1. its height will be decreased;
 2. the step range of all neighbouring stones of the same color will be decreased as well;
 3. a new Entity, representing the stone taken from the top of the tower, will be created and returned.
 If the moving token is a stone:
 1. the position will be marked as an empty one;
 2. all neighbouring towers of the other color will get a new move to this newly empty position;
 3. the same token will be returned.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>ent</code> - the token which has to be moved (if it is a simple stone) or dismantled (if it is a tower).</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the stone which is to be placed on the end position of the current move.</dd>
</dl>
</li>
</ul>
<a name="checkMoveForTower-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>checkMoveForTower</h4>
<pre>private&nbsp;boolean&nbsp;checkMoveForTower(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos,
                                  <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col)</pre>
<div class="block">Returns true if a tower of the color col neighbouring to the position pos can be dismantled on this position.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>pos</code> - the position in question.</dd>
<dd><code>col</code> - the color of the tower in question.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if a tower of the color col neighbouring to the position pos can be dismantled on this position.</dd>
</dl>
</li>
</ul>
<a name="checkMoveForStone-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>checkMoveForStone</h4>
<pre>private&nbsp;boolean&nbsp;checkMoveForStone(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos,
                                  <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col,
                                  int&nbsp;dist)</pre>
<div class="block">Returns true if a stone of the color col can go to the position pos taking into account the art of the move in question (close or remote one).</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>pos</code> - the position in question.</dd>
<dd><code>col</code> - the color of the stone in question.</dd>
<dd><code>dist</code> - distance from the current stone position to the position in question.
             If dist == 1, the potential move is a close one, else - a remote one.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if the stone in question can go to the specified position.</dd>
</dl>
</li>
</ul>
<a name="changeEnd-towerwarspp.board.Entity-towerwarspp.preset.Position-towerwarspp.preset.Position-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>changeEnd</h4>
<pre>private&nbsp;void&nbsp;changeEnd(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent,
                       <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;start,
                       <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;end)</pre>
<div class="block">Conducts changes caused by the current move, which is specified for the token ent, in respect to its end position.
 Case 1: the end position is empty:
 1. the token in question will be placed on this position on the board;
 2. all corresponding changes will be commited.
 Case 2: the end position is the opponent's base:
 1. the token in question will replace the base on the board;
 2. no other changes will be commited.
 Case 3: there is the opponent's token (stone or tower) on the end position:
 1.1. if the opponent's token is a tower,
 it will be replaced or blocked by the moving stone, depending on the art of the move (close or remote one);
 1.2. if the opponent's token is a simple stone,
 it will be replaced by the moving stone;
 2. all corresponding changes will be commited.
 Case 4: there is a token of the same color on the end position:
 1.1. if the other token is a stone:
 a new tower with the height 1 will be builded;
 1.2. if the other token is a tower which is not blocked (and has not reached the maximal height),
 the height of the tower will be inncreased;
 1.3. if the other token is a blocked tower,
 this  tower will be unblocked;
 2. the moving stone will be removed from the list of movable tokens;
 3. all other corresponding changes will be commited.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>ent</code> - the token in question which has to be moved to the specified end position.</dd>
<dd><code>end</code> - the position to which the token in question has to be moved.</dd>
</dl>
</li>
</ul>
<a name="blockTower-towerwarspp.board.Entity-towerwarspp.board.Entity-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>blockTower</h4>
<pre>private&nbsp;void&nbsp;blockTower(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower,
                        <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;blockingStone)</pre>
<div class="block">Blocks the specified tower and commits all the necessary changes:
 1. the range of neighbouring stones of the same color will be decreased;
 2. if the tower in question was of the maximal height,
 towers and stones of the same color which can reach the tower's position will get a new possible move to this position.
 3. the blocking stone will be removed from the list of movable tokens.
 4. for all opponent's stones which have a remote move to the tower's position:
 this move will be removed from their lists of possible moves.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>tower</code> - the tower to be blocked.</dd>
<dd><code>blockingStone</code> - the stone which is going to block the tower.</dd>
</dl>
</li>
</ul>
<a name="unblockTower-towerwarspp.board.Entity-towerwarspp.board.Entity-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>unblockTower</h4>
<pre>private&nbsp;void&nbsp;unblockTower(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower,
                          <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;unblockingStone)</pre>
<div class="block">Unblocks the specified tower, removes the and commits all the necessary changes.
 1. the range of neighbouring stones of the same color will be inreased;
 2. the unblocking stone will be removed from the list of movable tokens.
 3. if the unblocked tower is of the maximal height,
 for all tokens of the same color which have a possible move to the tower's position:
 this move will be removed from their lists of possible moves.
 4. for all opponent's stones which could reach the tower's position with a remote move:
 this move will be added to their lists of possible moves.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>tower</code> - the tower to be unblocked.</dd>
<dd><code>unblockingStone</code> - the stone which is going to unblock the tower.</dd>
</dl>
</li>
</ul>
<a name="removeToken-towerwarspp.board.Entity-towerwarspp.board.Entity-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeToken</h4>
<pre>private&nbsp;void&nbsp;removeToken(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;ent,
                         <a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;removingStone)</pre>
<div class="block">Removes the specified token ent from the board replacing it with the stone removingStone.
 Commits some corresponding changes:
 1. the position in question will be closed for all neighbouring towers of the same color as the token ent.
 2. the position in question will be opened for all neighbouring towers of the same color as the token removingStone.
 3. the list of all possible moves of the token removingStone will be actualised with respect to its new position.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>ent</code> - the token to be removed.</dd>
<dd><code>removingStone</code> - the stone which is going to beat the specified opponent's token and take its place on the board.</dd>
</dl>
</li>
</ul>
<a name="actualiseTowerNeighbourIsEmpty-towerwarspp.preset.Position-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>actualiseTowerNeighbourIsEmpty</h4>
<pre>private&nbsp;void&nbsp;actualiseTowerNeighbourIsEmpty(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;emptyPos,
                                            <a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos,
                                            <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col)</pre>
<div class="block">Proves if there is a tower on the position pos which is not blocked and has color different from col.
 If so, adds a new move - to the position emptyPos - to the tower's possible moves.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>emptyPos</code> - the newly empty position.</dd>
<dd><code>pos</code> - some other position on the board neigbouring to emptyPos.</dd>
<dd><code>col</code> - the color of the player whose token has just left the position emptyPos.</dd>
</dl>
</li>
</ul>
<a name="positionClosed-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>positionClosed</h4>
<pre>private&nbsp;void&nbsp;positionClosed(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;closedPos,
                            <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col,
                            boolean&nbsp;forAll)</pre>
<div class="block">Removes the specified position from the list of possible moves for every token of the specified color
 if this token can reach the position and satisfies the specified requirement (if available).
 The parameter forAll indicates if the position in question has to be closed for all tokens
 of the specified color or only for those which can reach the position with a remote move.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>closedPos</code> - the position in question.</dd>
<dd><code>col</code> - the color of the tokens which are no more allowed to go to the position closedPos.</dd>
<dd><code>forAll</code> - indicates if the position in question has to be closed for all tokens
                  of the specified color (forAll == true) or only for those which can reach the position with a remote move (forAll == false).</dd>
</dl>
</li>
</ul>
<a name="positionOpened-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>positionOpened</h4>
<pre>private&nbsp;void&nbsp;positionOpened(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;openedPos,
                            <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col)</pre>
<div class="block">Adds the specified position to the list of possible moves for every token of the specified color
 if this token can reach the position.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>openedPos</code> - the position in question.</dd>
<dd><code>col</code> - the color of the tokens which are now allowed to go to the position openedPos if they can reach it.</dd>
</dl>
</li>
</ul>
<a name="positionOpenedStonesOnly-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>positionOpenedStonesOnly</h4>
<pre>private&nbsp;void&nbsp;positionOpenedStonesOnly(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;openedPos,
                                      <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col)</pre>
<div class="block">Adds the specified position to the list of possible moves for every stone (and not for the towers)
 if this stone can reach the position.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>openedPos</code> - the position in question.</dd>
<dd><code>col</code> - the color of the stones which are now allowed to go to the position openedPos if they can reach it.</dd>
</dl>
</li>
</ul>
<a name="actualiseTowerNeighboursRemoveRanges-towerwarspp.board.Entity-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>actualiseTowerNeighboursRemoveRanges</h4>
<pre>private&nbsp;void&nbsp;actualiseTowerNeighboursRemoveRanges(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower,
                                                  int&nbsp;change)</pre>
<div class="block">Commits changes caused by blocking, removing or dismantling of a tower in respect to its neighbours of the same color.
 1. For all neighbouring stones of the same color: their step ranges will be decreased and all corresponding
 remote moves will be removed from their lists of possible moves.
 2. For all neighbouring towers of the same color: no changes are needed.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>tower</code> - the tower in question.</dd>
<dd><code>change</code> - the necessary change in the step range: will be subtracted from the current range values of the neighbouring stones.</dd>
</dl>
</li>
</ul>
<a name="actualiseOwnTowerUnblockedOrIncreased-towerwarspp.board.Entity-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>actualiseOwnTowerUnblockedOrIncreased</h4>
<pre>private&nbsp;void&nbsp;actualiseOwnTowerUnblockedOrIncreased(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower,
                                                   int&nbsp;change)</pre>
<div class="block">Commits changes caused by creating, increasing or unblocking of a tower in respect to its neighbours of the same color.
 1. For all neighbouring stones of the same color: their step ranges will be increased and all newly available
 remote moves will be added to their lists of possible moves.
 2. For all neighbouring towers of the same color:
 no changes are needed if the height of the increased/unblocked tower is not maximum.
 3. If the tower in question has reached the maximum height, all moves to its position will be removed
 from the lists of possible moves for all tokens (stones and towers) of the same color in case they had such moves.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>tower</code> - the tower whose height has been increased.</dd>
<dd><code>change</code> - the necessary change in the step range: will be added to the current range values of the neighbouring stones.</dd>
</dl>
</li>
</ul>
<a name="actualiseTowerRemoved-towerwarspp.board.Entity-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>actualiseTowerRemoved</h4>
<pre>private&nbsp;void&nbsp;actualiseTowerRemoved(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower)</pre>
<div class="block">Commits some necessary changes caused by removing a tower.
 Case 1: the removed tower was blocked:
 its position will be opened for all opponent's tokens (stones and towers);
 Case 2: the removed tower was not blocked:
 1. the step ranges of the neighbouring stones of the same color will be decreased
 and the corresponding remote moves will be removed from their lists of possible moves
 2. If the tower had the maximal height, its position will be opened for all stones of the same color.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>tower</code> - the tower that has been removed.</dd>
</dl>
</li>
</ul>
<a name="positionClosedAndOpenedForTowers-towerwarspp.preset.Position-towerwarspp.preset.PlayerColor-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>positionClosedAndOpenedForTowers</h4>
<pre>private&nbsp;void&nbsp;positionClosedAndOpenedForTowers(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;pos,
                                              <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col,
                                              boolean&nbsp;openForOpponent)</pre>
<div class="block">Removes the specified position from the list of possible moves for all neighbouring towers of the specified color.
 If the parameter openForOpponent has value true, the same position will be added to the possible moves
 list of the neighbouring towers of the other color.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>pos</code> - the position in question.</dd>
<dd><code>col</code> - the color of the towers which are no more allowed to be dismantled on the position closedPos.</dd>
<dd><code>openForOpponent</code> - this parameter defines, if the same position has to be added to the list of possible moves
                        for the towers of th other color (if so, openForOpponent == true).</dd>
</dl>
</li>
</ul>
<a name="actualiseTowerAddStone-towerwarspp.board.Entity-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>actualiseTowerAddStone</h4>
<pre>private&nbsp;void&nbsp;actualiseTowerAddStone(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower)</pre>
<div class="block">Commits all necessary changes caused by putting a stone on the top of the specified token (stone or tower):
 1. The token's height will be increased.
 2. The tower moves will be found if originally the token was not a tower.
 3. For all neighbouring stones of the same color: their step ranges will be increased respectively and all newly available
 remote moves will be added to their lists of possible moves.
 4. If the increased tower has reached the maximum height, all moves to its position will be removed
 from the lists of possible moves for all tokens (stones and towers) of the same color in case they had such moves.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>tower</code> - the token whose height has been increased by a new stone.</dd>
</dl>
</li>
</ul>
<a name="actualiseTowerRemoveStone-towerwarspp.board.Entity-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>actualiseTowerRemoveStone</h4>
<pre>private&nbsp;void&nbsp;actualiseTowerRemoveStone(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower)</pre>
<div class="block">Commits all necessary changes caused by removing a stone from the top of the specified tower:
 1. The tower's height will be decreased.
 2. For all neighbouring stones of the same color: their step ranges will be decreased respectively and all corresponding
 remote moves will be removed from their lists of possible moves.
 3. If the tower had the maximal height, its position will be opened for all tokens (stones and towers) of the same color.
 4. If there is only a simple stone left from the tower,
 its possible moves will be calculated and added to its list of possible moves.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>tower</code> - the tower whose top stone has to be removed.</dd>
</dl>
</li>
</ul>
<a name="findTowerMoves-towerwarspp.board.Entity-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>findTowerMoves</h4>
<pre>private&nbsp;void&nbsp;findTowerMoves(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;tower)</pre>
<div class="block">Finds all possible moves for the specified tower.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>tower</code> - the tower whose possible moves have to be found.</dd>
</dl>
</li>
</ul>
<a name="findStoneMoves-towerwarspp.board.Entity-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>findStoneMoves</h4>
<pre>private&nbsp;void&nbsp;findStoneMoves(<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&nbsp;stone)</pre>
<div class="block">Finds all possible moves for the specified stone.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>stone</code> - the stone whose possible moves have to be found.</dd>
</dl>
</li>
</ul>
<a name="initialiseBoard--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>initialiseBoard</h4>
<pre>private&nbsp;void&nbsp;initialiseBoard()</pre>
<div class="block">Initialises the board before the first move:
 1. creates and sets all necessary entities on their start positions;
 2. adds all entities except the bases to the corresponding red and blue lists of entities (lists of movable tokens).</div>
</li>
</ul>
<a name="initialiseEntities-towerwarspp.preset.Position-int-towerwarspp.preset.PlayerColor-java.util.Vector-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>initialiseEntities</h4>
<pre>private&nbsp;void&nbsp;initialiseEntities(<a href="../../towerwarspp/preset/Position.html" title="class in towerwarspp.preset">Position</a>&nbsp;base,
                                int&nbsp;dist,
                                <a href="../../towerwarspp/preset/PlayerColor.html" title="enum in towerwarspp.preset">PlayerColor</a>&nbsp;col,
                                java.util.Vector&lt;<a href="../../towerwarspp/board/Entity.html" title="class in towerwarspp.board">Entity</a>&gt;&nbsp;list)</pre>
<div class="block">Initialises all entities of the specified color before the first move.
 For all positions on the board whose distance to the specified base position is not greater than the specified distance:
 1. creates new entity of the specified color,
 2. sets this entity on the position,
 3. determines the entity's possible moves,
 4. adds the new entity to the corresponding entity list.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>base</code> - position of the base which determines positions of the new entities.</dd>
<dd><code>dist</code> - the maximal allowed distance to the base.</dd>
<dd><code>col</code> - the color of the player whose entities have to be created and set on the board.</dd>
<dd><code>list</code> - the list where all newly created entities have to be stored.</dd>
</dl>
</li>
</ul>
<a name="viewer--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>viewer</h4>
<pre>public&nbsp;<a href="../../towerwarspp/board/BViewer.html" title="class in towerwarspp.board">BViewer</a>&nbsp;viewer()</pre>
<div class="block">Returns a viewer for this board.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../towerwarspp/preset/Viewable.html#viewer--">viewer</a></code>&nbsp;in interface&nbsp;<code><a href="../../towerwarspp/preset/Viewable.html" title="interface in towerwarspp.preset">Viewable</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a viewer for this board.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/SimpleBoard.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-all.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../towerwarspp/board/MoveScore.html" title="class in towerwarspp.board"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li>Next&nbsp;Class</li>
</ul>
<ul class="navList">
<li><a href="../../index.html?towerwarspp/board/SimpleBoard.html" target="_top">Frames</a></li>
<li><a href="SimpleBoard.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
